###########################################################################
#
#   Copyright (c) 2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__doc__ = """Wrapper module for abstracted locking on UNIX and Windows systems."""

try:

	import fcntl

	def lock_file(file):
		"""Tries to gain a lock on the given file."""

		fcntl.flock(file.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB)


	def unlock_file(file):
		"""Tries to release the lock on the given file."""

		fcntl.flock(file.fileno(), fcntl.LOCK_UN)


except ImportError:

	import winlock

	def lock_file(file):
		"""Tries to gain a lock on the given file."""


	def unlock_file(file):
		"""Tries to release the lock on the given file."""